'Breakout
nomainwin

    speed = 80

    dim block(1000)
    dim blockx(1000)
    dim blocky(1000)

    loadbmp "paddle1","bmp\paddle1.bmp"
    loadbmp "ball1","bmp\ball1.bmp"
    loadbmp "block1","bmp\block1.bmp"
    loadbmp "bg1","bmp\bg1.bmp"
    loadbmp "bg2","bmp\bg2.bmp"

    WindowWidth = 600
    WindowHeight = 400
    UpperLeftX = 1
    UpperLeftY = 1

    graphicbox #breakout.gb, 0, 0, 601, 401
    open "Breakout" for window as #breakout

    print #breakout, "trapclose [quit]";

    print #breakout.gb, "addsprite paddle paddle1";
    print #breakout.gb, "addsprite ball ball1";
    print #breakout.gb, "addsprite ball1 ball1";
    print #breakout.gb, "addsprite ball2 ball1";
    print #breakout.gb, "background bg1";

    print #breakout.gb, "drawsprites";

    gosub [initializeGame]

    print #breakout.gb, "when characterInput [keyPressed]";
    print #breakout.gb, "setfocus";

        ballxv = 7
        ballyv = -8
        print #breakout.gb, "spritemovexy ball 7 -7";

    print #breakout.gb, "drawsprites"
    notice "Welcome to Breakout!"+chr$(13)+"Use keypad 1 to move paddle left"+chr$(13)+"Use keypad 3 to move paddle left"+chr$(13)+"Hit ball on edge of paddle to alter trajectory"+chr$(13)+"Get ready..."

    timer speed, [animate]

[inputLoop]
'    scan
    wait

[animate]

    change = 0

    print #breakout.gb, "spritexy? ball ballx bally";

    print #breakout.gb, "spritecollides ball list$";

    for blockNumber = 1 to 9
        blockName$ = "block0"+str$(blockNumber)
        if instr(blockName$,list$) > 0 then
            print #breakout.gb, "spritexy ";blockName$;" -200 -200";
            change = 1
            blockTotal = blockTotal - 1
            score = score + 10
            if ballx <= blockx(blockNumber) then ballxv = 0 - ballxv ' ok
            if ballx >= blockx(blockNumber)+30 then ballxv = 0 - ballxv
            if bally <= blocky(blockNumber) then ballyv = 0 - ballyv ' ok
            if bally >= blocky(blockNumber)+20 then ballyv = 0 - ballyv
        end if
    next blockNumber
    for blockNumber = 10 to blockCount
        blockName$ = "block"+str$(blockNumber)
        if instr(blockName$,list$) > 0 then
            print #breakout.gb, "spritexy ";blockName$;" -200 -200";
            change = 1
            blockTotal = blockTotal - 1
            score = score + 10
            if ballx <= blockx(blockNumber) then ballxv = 0 - ballxv
            if ballx >= blockx(blockNumber)+30 then ballxv = 0 - ballxv
            if bally <= blocky(blockNumber) then ballyv = 0 - ballyv
            if bally >= blocky(blockNumber)+20 then ballyv = 0 - ballyv
        end if
    next blockNumber

    if instr("paddle",list$) then' and bally < 300 - 30 then
        if ballx+6 <= paddlex+15 then ballxv = ballxv-1
        if ballx+6 >= paddlex+45 then ballxv = ballxv+1
        ballyv = 0 - ballyv
        change = 1
    end if

    if blockTotal < 1 then goto [reinitializeGame]

    if ballx < 2 then ballxv = 0 - ballxv:change = 1
    if ballx > 578 then ballxv = 0 - ballxv:change = 1
    if bally < 2 then ballyv = 0 - ballyv:change = 1
    if bally > 370 then
        timer 0
        balls = balls - 1
        if balls < 0 then goto [gameOver]
        goto [nextBall]
    end if
    if change = 1 then print #breakout.gb, "spritemovexy ball ";ballxv;" ";ballyv;

    print #breakout.gb, "drawsprites";
    goto [inputLoop]

[nextBall]
    if balls = 1 then print #breakout.gb, "spritevisible ball2 off";
    if balls = 0 then print #breakout.gb, "spritevisible ball1 off";
    notice "Get ready..."
    print #breakout.gb, "spritexy paddle ";300-30;" ";400-60;
        paddlex = 300-30
    print #breakout.gb, "spritexy ball ";300-6;" ";400-60-12;
        ballxv = 7
        ballyv = -7
        print #breakout.gb, "spritemovexy ball 7 -7";
    timer speed, [animate]
    goto [inputLoop]

[keyPressed]
    key$ = Inkey$
    change=0
    if key$ = "3" then paddlex = paddlex + 10:change=1: if paddlex > 600-60 then paddlex = 600-60
    if key$ = "1" then paddlex = paddlex - 10:change=1: if paddlex < 0 then paddlex = 0
    if change = 1 then print #breakout.gb, "spritexy paddle ";paddlex;" ";400-60
    goto [inputLoop]

[initializeGame]
    balls = 2
    blockCount = 0
    for blkx = 1 to 13
        for blky = 1 to 5
            blockCount = blockCount + 1
            block(blockCount) = 1
            blockx(blockCount) = blkx*40
            blocky(blockCount) = blky*30
            if blockCount < 10 then blockName$ = "block0"+str$(blockCount)
            if blockCount > 9 then blockName$ = "block"+str$(blockCount)
            print #breakout.gb, "addsprite ";blockName$;" block1"
            print #breakout.gb, "spritexy ";blockName$;" ";(blkx*40);" ";(blky*30);
        next blky
    next blkx
    blockTotal = blockCount
    print #breakout.gb, "spritexy ball1 ";550;" ";400-40
    print #breakout.gb, "spritexy ball2 ";570;" ";400-40
    print #breakout.gb, "spritexy paddle ";300-30;" ";400-60;
        paddlex = 300-30
    print #breakout.gb, "spritexy ball ";300-6;" ";400-60-12;
    return

[reinitializeGame]
    print #breakout.gb, "background bg2";
    blockCount = 0
    for blkx = 1 to 14
        for blky = 0 to 7
            blockCount = blockCount + 1
            block(blockCount) = 1
            blockx(blockCount) = blkx*40
            blocky(blockCount) = blky*30
            if blockCount < 10 then blockName$ = "block0"+str$(blockCount)
            if blockCount > 9 then blockName$ = "block"+str$(blockCount)
            print #breakout.gb, "addsprite ";blockName$;" block1"
            print #breakout.gb, "spritexy ";blockName$;" ";(blkx*40);" ";(blky*30);
        next blky
    next blkx
    blockTotal = blockCount
    print #breakout.gb, "spritexy ball1 ";550;" ";400-40
    print #breakout.gb, "spritexy ball2 ";570;" ";400-40
    print #breakout.gb, "spritexy paddle ";300-30;" ";400-60;
        paddlex = 300-30
    print #breakout.gb, "spritexy ball ";300-6;" ";400-60-12;
    ballxv = 7
    notice "Get ready..."
    speed = 80
    timer speed, [animate]
    goto [inputLoop]

[gameOver]
    notice "Game over!"+chr$(13)+"Your score: "+chr$(13)+str$(score)

[quit]
    unloadbmp "paddle1"
    unloadbmp "ball1"
    unloadbmp "block1"
    unloadbmp "bg1"
    close #breakout
    end
